import { Provider, SignerType } from '0x.js';
import { ErcDex } from './generated/ercdex';
import { Web3EnabledService } from './web3-enabled-service';
export interface ICancelOrderParams {
    /**
     * Web3 provider engine
     */
    provider: Provider;
    /**
     * Order
     */
    order: ErcDex.Api.Order;
    signerType: SignerType;
}
/**
 * Cancel an order by orderHash; returns txHash if successful
 */
export declare class CancelOrder extends Web3EnabledService<ErcDex.Api.ICancelOrderResult> {
    private readonly params;
    constructor(params: ICancelOrderParams);
    protected run(): Promise<ErcDex.Api.ICancelOrderResult>;
}
