import { Provider, SignerType } from '0x.js';
import { ErcDex } from './generated/ercdex';
import { Web3EnabledService } from './web3-enabled-service';
export interface IFillOrderParams {
    provider: Provider;
    /**
     * Collection of orders and fill amounts
     */
    fills: ErcDex.Api.IOrderFill[];
    /**
     * Account filling order
     */
    taker: string;
    signerType: SignerType;
}
export declare class FillOrders extends Web3EnabledService<ErcDex.Api.FillReceipt> {
    private readonly params;
    constructor(params: IFillOrderParams);
    protected run(): Promise<ErcDex.Api.FillReceipt>;
}
