"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable */
var api_service_1 = require("../api-service");
var token_cache_1 = require("../token-cache");
var ReconnectingWebsocket = require('reconnecting-websocket');
var ErcDex;
(function (ErcDex) {
    var baseApiUrl;
    var apiKeyId;
    var hasWebSocket;
    var socketOpen = false;
    var subscriptions = {};
    var send = function (message, tries) {
        if (tries === void 0) { tries = 0; }
        if (socketOpen) {
            ErcDex.socket.send(message);
            return;
        }
        // retry for 20 seconds
        if (tries < 20) {
            setTimeout(function () {
                send(message, tries + 1);
            }, 250);
        }
        else {
            console.log('failed to send');
        }
    };
    ErcDex.getApiKeyId = function () { return apiKeyId; };
    /**
     * Initialize the Aqueduct client. Required to use the client.
     */
    ErcDex.Initialize = function (params) {
        var hasProcess = typeof process !== 'undefined' && process.env;
        var host = (params && params.host) || (hasProcess && process.env.AQUEDUCT_HOST) || 'api.ercdex.com';
        baseApiUrl = "https://" + host;
        if (params) {
            apiKeyId = params.apiKeyId;
        }
        if (hasProcess && baseApiUrl.indexOf('localhost') !== -1) {
            process.env['NODE_TLS_REJECT_UNAUTHORIZED'] = 0;
        }
        hasWebSocket = typeof WebSocket !== 'undefined';
        if (!hasWebSocket) {
            console.warn('No WebSocket found in global namespace; subscriptions will not be configured.');
            return;
        }
        ErcDex.socket = new ReconnectingWebsocket("wss:" + host, undefined);
        ErcDex.socket.onopen = function () {
            Object.keys(subscriptions).map(function (k) { return subscriptions[k]; }).forEach(function (s) {
                if (s && !s.subActive) {
                    s.resub();
                    s.subActive = true;
                }
            });
            socketOpen = true;
        };
        ErcDex.socket.onclose = function () {
            Object.keys(subscriptions).map(function (k) { return subscriptions[k]; }).forEach(function (s) {
                if (s) {
                    s.subActive = false;
                }
            });
            socketOpen = false;
        };
        ErcDex.socket.onmessage = function (event) {
            try {
                var data_1 = JSON.parse(event.data);
                if (data_1.channel) {
                    var sub = subscriptions[data_1.channel];
                    if (sub) {
                        sub.callbacks.forEach(function (cb) { return cb(data_1.data); });
                    }
                }
            }
            catch (err) {
                return;
            }
        };
    };
    /**
     * Namespace representing REST API for ERC dEX
     */
    var Api;
    (function (Api) {
        var AggregatedOrdersService = /** @class */ (function (_super) {
            __extends(AggregatedOrdersService, _super);
            function AggregatedOrdersService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            AggregatedOrdersService.prototype.get = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/aggregated_orders"
                        };
                        requestParams.queryParameters = {
                            baseSymbol: params.baseSymbol,
                            quoteSymbol: params.quoteSymbol,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return AggregatedOrdersService;
        }(api_service_1.ApiService));
        Api.AggregatedOrdersService = AggregatedOrdersService;
        var AssetPairsService = /** @class */ (function (_super) {
            __extends(AssetPairsService, _super);
            function AssetPairsService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            /**
             * Get a list of supported asset pairs
             */
            AssetPairsService.prototype.get = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/asset_pairs"
                        };
                        requestParams.queryParameters = {
                            page: params.page,
                            per_page: params.per_page,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return AssetPairsService;
        }(api_service_1.ApiService));
        Api.AssetPairsService = AssetPairsService;
        var NetworksService = /** @class */ (function (_super) {
            __extends(NetworksService, _super);
            function NetworksService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            /**
             * Get supported network info
             */
            NetworksService.prototype.getSupportedNetwork = function (headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/networks"
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            /**
             * Determine if app is in maintenance mode
             */
            NetworksService.prototype.isMaintenance = function (headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/networks/maintenance"
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return NetworksService;
        }(api_service_1.ApiService));
        Api.NetworksService = NetworksService;
        var NotificationsService = /** @class */ (function (_super) {
            __extends(NotificationsService, _super);
            function NotificationsService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            /**
             * Get active notifications for an account
             */
            NotificationsService.prototype.get = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/notifications"
                        };
                        requestParams.queryParameters = {
                            account: params.account,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return NotificationsService;
        }(api_service_1.ApiService));
        Api.NotificationsService = NotificationsService;
        var OrdersService = /** @class */ (function (_super) {
            __extends(OrdersService, _super);
            function OrdersService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            /**
             * Submit a signed order
             */
            OrdersService.prototype.createOrder = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'POST',
                            url: baseApiUrl + "/api/v1/orders"
                        };
                        requestParams.body = params.request;
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            /**
             * Get a list of orders
             */
            OrdersService.prototype.get = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/orders"
                        };
                        requestParams.queryParameters = {
                            open: params.open,
                            page: params.page,
                            per_page: params.per_page,
                            exchangeAddress: params.exchangeAddress,
                            feeRecipientAddress: params.feeRecipientAddress,
                            takerAssetData: params.takerAssetData,
                            makerAssetData: params.makerAssetData,
                            senderAddress: params.senderAddress,
                            traderAssetData: params.traderAssetData,
                            traderAddress: params.traderAddress,
                            takerAssetAddress: params.takerAssetAddress,
                            takerAddress: params.takerAddress,
                            makerAssetAddress: params.makerAssetAddress,
                            makerAddress: params.makerAddress,
                            makerAssetType: params.makerAssetType,
                            takerAssetType: params.takerAssetType,
                            pair: params.pair,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            /**
             * Get a single order by hash
             */
            OrdersService.prototype.getOrderByHash = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/order/" + params.orderHash
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            OrdersService.prototype.getOrderConfig = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/order_config"
                        };
                        requestParams.queryParameters = {
                            makerAddress: params.makerAddress,
                            takerAddress: params.takerAddress,
                            makerAssetAmount: params.makerAssetAmount,
                            takerAssetAmount: params.takerAssetAmount,
                            makerAssetData: params.makerAssetData,
                            takerAssetData: params.takerAssetData,
                            exchangeAddress: params.exchangeAddress,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            OrdersService.prototype.getOrderbook = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/orderbook"
                        };
                        requestParams.queryParameters = {
                            baseAssetData: params.baseAssetData,
                            quoteAssetData: params.quoteAssetData,
                            per_page: params.per_page,
                            page: params.page,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            /**
             * Cancel one or more orders
             */
            OrdersService.prototype.cancel = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'POST',
                            url: baseApiUrl + "/api/v1/orders/cancel"
                        };
                        requestParams.body = params.request;
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return OrdersService;
        }(api_service_1.ApiService));
        Api.OrdersService = OrdersService;
        var ReportsService = /** @class */ (function (_super) {
            __extends(ReportsService, _super);
            function ReportsService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            ReportsService.prototype.getTickerData = function (headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/reports/ticker"
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return ReportsService;
        }(api_service_1.ApiService));
        Api.ReportsService = ReportsService;
        var TickerService = /** @class */ (function (_super) {
            __extends(TickerService, _super);
            function TickerService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            TickerService.prototype.get = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/ticker"
                        };
                        requestParams.queryParameters = {
                            granularity: params.granularity,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return TickerService;
        }(api_service_1.ApiService));
        Api.TickerService = TickerService;
        var TradeService = /** @class */ (function (_super) {
            __extends(TradeService, _super);
            function TradeService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            /**
             * Redeem a signed quote (see RequestFill to receive a quote)
             */
            TradeService.prototype.fill = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'POST',
                            url: baseApiUrl + "/api/v1/trade/fill"
                        };
                        requestParams.body = params.request;
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            /**
             * Request to fill an order; returns a quote payload that can be signed and redeemed to begin execution
             */
            TradeService.prototype.requestFill = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'POST',
                            url: baseApiUrl + "/api/v1/trade/request_fill"
                        };
                        requestParams.body = params.request;
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            /**
             * Get a quote for a requested quantity
             */
            TradeService.prototype.getMarketQuote = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'POST',
                            url: baseApiUrl + "/api/v1/trade/market_quote"
                        };
                        requestParams.body = params.request;
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            /**
             * Get a quote by percentage
             */
            TradeService.prototype.getMarketQuoteByPercent = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'POST',
                            url: baseApiUrl + "/api/v1/trade/market_quote_by_percent"
                        };
                        requestParams.body = params.request;
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            /**
             * Get a receipt of an attempted fill
             */
            TradeService.prototype.getReceipt = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/trade/receipt/" + params.id
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            TradeService.prototype.getReceipts = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/trade/receipts"
                        };
                        requestParams.queryParameters = {
                            page: params.page,
                            per_page: params.per_page,
                            taker_address: params.taker_address,
                            pair: params.pair,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return TradeService;
        }(api_service_1.ApiService));
        Api.TradeService = TradeService;
        var TradingViewService = /** @class */ (function (_super) {
            __extends(TradingViewService, _super);
            function TradingViewService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            TradingViewService.prototype.getLogs = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/trading_view"
                        };
                        requestParams.queryParameters = {
                            pair: params.pair,
                            resolution: params.resolution,
                            startDate: params.startDate,
                            endDate: params.endDate,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return TradingViewService;
        }(api_service_1.ApiService));
        Api.TradingViewService = TradingViewService;
        var TradeHistoryLogsService = /** @class */ (function (_super) {
            __extends(TradeHistoryLogsService, _super);
            function TradeHistoryLogsService() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            TradeHistoryLogsService.prototype.get = function (params, headers) {
                return __awaiter(this, void 0, void 0, function () {
                    var requestParams;
                    return __generator(this, function (_a) {
                        requestParams = {
                            method: 'GET',
                            url: baseApiUrl + "/api/v1/trade_history_logs"
                        };
                        requestParams.queryParameters = {
                            page: params.page,
                            per_page: params.per_page,
                            sort_order: params.sort_order,
                            sort_direction: params.sort_direction,
                            relayer: params.relayer,
                            maker: params.maker,
                            fee_recipient: params.fee_recipient,
                            maker_token_address: params.maker_token_address,
                            maker_token_symbol: params.maker_token_symbol,
                            taker: params.taker,
                            taker_token_address: params.taker_token_address,
                            taker_token_symbol: params.taker_token_symbol,
                            order_hash: params.order_hash,
                            token_address: params.token_address,
                            token_symbol: params.token_symbol,
                            tx_hash: params.tx_hash,
                            trader: params.trader,
                            min_date: params.min_date,
                            max_date: params.max_date,
                            format: params.format,
                            pair: params.pair,
                        };
                        requestParams.apiKeyId = apiKeyId;
                        return [2 /*return*/, this.executeRequest(requestParams, headers)];
                    });
                });
            };
            return TradeHistoryLogsService;
        }(api_service_1.ApiService));
        Api.TradeHistoryLogsService = TradeHistoryLogsService;
    })(Api = ErcDex.Api || (ErcDex.Api = {}));
    /**
     * Namespace containing socket related events
     */
    var Events;
    (function (Events) {
        /* tslint:disable */ /**
    * This file was automatically generated by json-schema-to-typescript.
    * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
    * and run json-schema-to-typescript to regenerate this file.
    */
        var SocketEvent = /** @class */ (function () {
            function SocketEvent() {
            }
            /**
             * Subscribe to this event
             * @param params Payload to submit to the server
             * @param cb Handler for event broadcasts
             */
            SocketEvent.prototype.subscribe = function (params, cb) {
                if (!hasWebSocket) {
                    throw new Error('WebSockets not configured.');
                }
                this.params = params;
                this.callback = cb;
                var channel = this.getChannel(params);
                send("sub:" + channel);
                var sub = subscriptions[channel];
                if (sub) {
                    sub.callbacks.push(this.callback);
                }
                else {
                    subscriptions[channel] = {
                        callbacks: [this.callback],
                        resub: function () {
                            send("sub:" + channel);
                        },
                        subActive: true
                    };
                }
                return this;
            };
            /**
             * Dispose of an active subscription
             */
            SocketEvent.prototype.unsubscribe = function () {
                send("unsub:" + this.getChannel(this.params));
                subscriptions[this.getChannel(this.params)] = undefined;
            };
            SocketEvent.prototype.getChannel = function (params) {
                var channel = this.path;
                Object.keys(params).forEach(function (k) {
                    channel = channel.replace(":" + k, params[k]);
                });
                return channel.toLowerCase();
            };
            return SocketEvent;
        }());
        Events.SocketEvent = SocketEvent;
        ;
        /**
         * Order changes relating to a token pair
         */
        var PairOrderChange = /** @class */ (function (_super) {
            __extends(PairOrderChange, _super);
            function PairOrderChange() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.path = 'pair-order-change/:baseSymbol/:quoteSymbol';
                return _this;
            }
            return PairOrderChange;
        }(SocketEvent));
        Events.PairOrderChange = PairOrderChange;
        ;
        /**
         * Order changes related to an account address
         */
        var AccountOrderChange = /** @class */ (function (_super) {
            __extends(AccountOrderChange, _super);
            function AccountOrderChange() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.path = 'account-order-change/:account';
                return _this;
            }
            return AccountOrderChange;
        }(SocketEvent));
        Events.AccountOrderChange = AccountOrderChange;
        ;
        /**
         * Notifications related to an account address
         */
        var AccountNotification = /** @class */ (function (_super) {
            __extends(AccountNotification, _super);
            function AccountNotification() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.path = 'account-notification/:account';
                return _this;
            }
            return AccountNotification;
        }(SocketEvent));
        Events.AccountNotification = AccountNotification;
        ;
        /**
         * Price Ticker Updates
         */
        var TickerSubscription = /** @class */ (function (_super) {
            __extends(TickerSubscription, _super);
            function TickerSubscription() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.path = 'ticker';
                return _this;
            }
            return TickerSubscription;
        }(SocketEvent));
        Events.TickerSubscription = TickerSubscription;
        ;
        /**
         * Aggregated Order Feed
         */
        var AggregatedOrderFeed = /** @class */ (function (_super) {
            __extends(AggregatedOrderFeed, _super);
            function AggregatedOrderFeed() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.path = 'aggregated-order-feed/:baseSymbol/:quoteSymbol';
                return _this;
            }
            return AggregatedOrderFeed;
        }(SocketEvent));
        Events.AggregatedOrderFeed = AggregatedOrderFeed;
        ;
        /**
         * State changes to FillReceipts associated with orders created by maker
         */
        var MakerFillReceiptChange = /** @class */ (function (_super) {
            __extends(MakerFillReceiptChange, _super);
            function MakerFillReceiptChange() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.path = 'maker-fill-receipt-change/:account';
                return _this;
            }
            return MakerFillReceiptChange;
        }(SocketEvent));
        Events.MakerFillReceiptChange = MakerFillReceiptChange;
        ;
        /**
         * State changes to FillReceipts filled by taker
         */
        var TakerFillReceiptChange = /** @class */ (function (_super) {
            __extends(TakerFillReceiptChange, _super);
            function TakerFillReceiptChange() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.path = 'taker-fill-receipt-change/:account';
                return _this;
            }
            return TakerFillReceiptChange;
        }(SocketEvent));
        Events.TakerFillReceiptChange = TakerFillReceiptChange;
        ;
        /**
         * State changes to FillReceipts belong to a certain asset pair
         */
        var PairFillReceiptChange = /** @class */ (function (_super) {
            __extends(PairFillReceiptChange, _super);
            function PairFillReceiptChange() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.path = 'pair-fill-receipt-change/:baseSymbol/:quoteSymbol';
                return _this;
            }
            return PairFillReceiptChange;
        }(SocketEvent));
        Events.PairFillReceiptChange = PairFillReceiptChange;
    })(Events = ErcDex.Events || (ErcDex.Events = {}));
    var Utils;
    (function (Utils) {
        Utils.Tokens = token_cache_1.tokenCache;
    })(Utils = ErcDex.Utils || (ErcDex.Utils = {}));
})(ErcDex = exports.ErcDex || (exports.ErcDex = {}));
//# sourceMappingURL=ercdex.js.map