"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var _0x_js_1 = require("0x.js");
var bignumber_js_1 = require("bignumber.js");
var ercdex_1 = require("./generated/ercdex");
var signing_utils_1 = require("./signing-utils");
var token_cache_1 = require("./token-cache");
var web3_enabled_service_1 = require("./web3-enabled-service");
exports.nullAddress = '0x0000000000000000000000000000000000000000';
exports.denormalizedTokenPrice = function (value, decimals) {
    return value.times(new bignumber_js_1.BigNumber(10).pow(18 - decimals));
};
var LimitOrder = /** @class */ (function (_super) {
    __extends(LimitOrder, _super);
    function LimitOrder(params) {
        var _this = _super.call(this, params.provider) || this;
        _this.params = params;
        return _this;
    }
    LimitOrder.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tokenPair, baseToken, quoteToken, makerAssetAmount, makerToken, takerAssetAmount, takerToken, zeroEx, exchangeAddress, orderConfig, err_1, expirationTimeSeconds, signOrderParams, signatureResults, err_2, order, signature, createdOrder;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, token_cache_1.tokenCache.getTokenPair(this.params.baseTokenSymbol, this.params.quoteTokenSymbol)];
                    case 1:
                        tokenPair = _a.sent();
                        baseToken = tokenPair.assetDataA;
                        quoteToken = tokenPair.assetDataB;
                        if (new bignumber_js_1.BigNumber(tokenPair.minAmount).greaterThan(this.params.quantityInWei)) {
                            throw new Error("order quantity must be greater than minimum allowed amount: " + this.params.quantityInWei + "/" + tokenPair.minAmount);
                        }
                        if (!new bignumber_js_1.BigNumber(this.params.quantityInWei).isInt()) {
                            throw new Error("order quantity must be an integer, got " + this.params.quantityInWei.toString());
                        }
                        if (this.params.type === 'buy') {
                            makerToken = quoteToken;
                            takerToken = baseToken;
                            takerAssetAmount = new bignumber_js_1.BigNumber(this.params.quantityInWei);
                            makerAssetAmount = exports.denormalizedTokenPrice(takerAssetAmount.times(new bignumber_js_1.BigNumber(this.params.price)), baseToken.decimals)
                                .round();
                        }
                        else {
                            makerToken = baseToken;
                            takerToken = quoteToken;
                            makerAssetAmount = new bignumber_js_1.BigNumber(this.params.quantityInWei);
                            takerAssetAmount = exports.denormalizedTokenPrice(makerAssetAmount.times(new bignumber_js_1.BigNumber(this.params.price)), baseToken.decimals)
                                .round();
                        }
                        zeroEx = this.zeroEx;
                        return [4 /*yield*/, zeroEx.exchange.getContractAddress()];
                    case 2:
                        exchangeAddress = _a.sent();
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 5, , 6]);
                        return [4 /*yield*/, new ercdex_1.ErcDex.Api.OrdersService().getOrderConfig({
                                exchangeAddress: exchangeAddress,
                                makerAddress: this.params.account,
                                makerAssetAmount: makerAssetAmount.toString(),
                                makerAssetData: _0x_js_1.ZeroEx.encodeERC20AssetData(makerToken.address),
                                takerAddress: exports.nullAddress,
                                takerAssetAmount: takerAssetAmount.toString(),
                                takerAssetData: _0x_js_1.ZeroEx.encodeERC20AssetData(takerToken.address)
                            })];
                    case 4:
                        orderConfig = _a.sent();
                        return [3 /*break*/, 6];
                    case 5:
                        err_1 = _a.sent();
                        console.error('failed to get order config...');
                        console.log(err_1);
                        throw err_1;
                    case 6: return [4 /*yield*/, this.validateRequest({
                            takerAssetAmount: takerAssetAmount,
                            makerAssetAmount: makerAssetAmount,
                            makerToken: makerToken,
                            takerToken: takerToken,
                            tokenPair: tokenPair
                        })];
                    case 7:
                        _a.sent();
                        expirationTimeSeconds = new bignumber_js_1.BigNumber(!this.params.expirationDate
                            ? 4102444800
                            : Math.floor(this.params.expirationDate.getTime() / 1000));
                        signOrderParams = {
                            zeroEx: zeroEx,
                            feeRecipientAddress: orderConfig.feeRecipientAddress,
                            makerFee: new bignumber_js_1.BigNumber(orderConfig.makerFee),
                            takerFee: new bignumber_js_1.BigNumber(orderConfig.takerFee),
                            senderAddress: orderConfig.senderAddress,
                            makerAddress: this.params.account,
                            makerAssetAddress: makerToken.address,
                            takerAssetAddress: takerToken.address,
                            exchangeAddress: exchangeAddress,
                            makerAssetAmount: makerAssetAmount,
                            takerAssetAmount: takerAssetAmount,
                            expirationTimeSeconds: expirationTimeSeconds,
                            signerType: this.params.signerType
                        };
                        _a.label = 8;
                    case 8:
                        _a.trys.push([8, 10, , 11]);
                        return [4 /*yield*/, signing_utils_1.SigningUtils.signOrder(signOrderParams)];
                    case 9:
                        signatureResults = _a.sent();
                        return [3 /*break*/, 11];
                    case 10:
                        err_2 = _a.sent();
                        console.error('failed to sign order');
                        throw new Error('INVALID_SIGNATURE');
                    case 11:
                        order = signatureResults.order, signature = signatureResults.signature;
                        return [4 /*yield*/, new ercdex_1.ErcDex.Api.OrdersService().createOrder({
                                request: {
                                    makerAddress: signOrderParams.makerAddress,
                                    makerAssetData: order.makerAssetData,
                                    takerAssetData: order.takerAssetData,
                                    takerAddress: order.takerAddress,
                                    feeRecipientAddress: order.feeRecipientAddress,
                                    senderAddress: order.senderAddress,
                                    exchangeAddress: order.exchangeAddress,
                                    expirationTimeSeconds: order.expirationTimeSeconds.toString(),
                                    makerFee: order.makerFee.toString(),
                                    takerFee: order.takerFee.toString(),
                                    salt: order.salt.toString(),
                                    makerAssetAmount: order.makerAssetAmount.toString(),
                                    takerAssetAmount: order.takerAssetAmount.toString(),
                                    signature: signature
                                }
                            })];
                    case 12:
                        createdOrder = _a.sent();
                        return [2 /*return*/, createdOrder];
                }
            });
        });
    };
    LimitOrder.prototype.validateRequest = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var makerToken, makerAssetAmount, zeroEx;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        makerToken = params.makerToken, makerAssetAmount = params.makerAssetAmount;
                        zeroEx = this.zeroEx;
                        return [4 /*yield*/, Promise.all([
                                (function () { return __awaiter(_this, void 0, void 0, function () {
                                    var makerBalance;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, zeroEx.erc20Token.getBalanceAsync(makerToken.address, this.params.account)];
                                            case 1:
                                                makerBalance = _a.sent();
                                                if (makerBalance.lessThan(makerAssetAmount)) {
                                                    throw new Error('insufficient token balance');
                                                }
                                                return [2 /*return*/];
                                        }
                                    });
                                }); })(),
                                (function () { return __awaiter(_this, void 0, void 0, function () {
                                    var makerAllowance;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, zeroEx.erc20Token.getProxyAllowanceAsync(makerToken.address, this.params.account)];
                                            case 1:
                                                makerAllowance = _a.sent();
                                                if (makerAllowance.lessThan(makerAssetAmount)) {
                                                    throw new Error('insufficient allowance');
                                                }
                                                return [2 /*return*/];
                                        }
                                    });
                                }); })()
                            ])];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return LimitOrder;
}(web3_enabled_service_1.Web3EnabledService));
exports.LimitOrder = LimitOrder;
//# sourceMappingURL=limit-order.js.map