import { SignerType, ZeroEx } from '0x.js';
import { Order } from '@0xproject/types';
import { BigNumber } from '@0xproject/utils';
export declare const SigningUtils: {
    signMessageAsync(zeroEx: ZeroEx, hexMessage: string, address: string, signerType: SignerType): Promise<string>;
    getExecuteTransactionHex(data: string, salt: BigNumber, signerAddress: string, exchangeAddress: string): string;
    signExecuteTransactionHexAsync(zeroEx: ZeroEx, executeTransactionHex: string, signerAddress: string, signerType: SignerType): Promise<string>;
    signOrder(params: {
        zeroEx: ZeroEx;
        makerAddress: string;
        makerAssetAddress: string;
        takerAssetAddress: string;
        senderAddress: string;
        exchangeAddress: string;
        feeRecipientAddress: string;
        makerAssetAmount: BigNumber;
        takerAssetAmount: BigNumber;
        makerFee: BigNumber;
        takerFee: BigNumber;
        expirationTimeSeconds: BigNumber;
        signerType: SignerType;
    }): Promise<{
        order: Order;
        signature: string;
    }>;
};
