"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var _0x_js_1 = require("0x.js");
var bignumber_js_1 = require("bignumber.js");
var chai_1 = require("chai");
var cancel_order_1 = require("../cancel-order");
var ercdex_1 = require("../generated/ercdex");
var limit_order_1 = require("../limit-order");
var constants_1 = require("./utils/constants");
var event_sink_1 = require("./utils/event-sink");
var should_throw_1 = require("./utils/should-throw");
var web3_provider_1 = require("./utils/web3-provider");
describe('LimitOrder', function () {
    it('should reject when using unsupported token pair', function () { return __awaiter(_this, void 0, void 0, function () {
        var err;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, should_throw_1.shouldThrow(function () { return new limit_order_1.LimitOrder({
                        account: constants_1.RELAYER_WALLET_ADDRESS,
                        price: '.005',
                        provider: web3_provider_1.web3Wrapper().getProvider(),
                        baseTokenSymbol: 'FAKE',
                        quoteTokenSymbol: 'TOKEN',
                        quantityInWei: new bignumber_js_1.BigNumber(1),
                        type: 'buy',
                        signerType: _0x_js_1.SignerType.Default
                    }).execute(); })];
                case 1:
                    err = _a.sent();
                    chai_1.expect(err.message).to.equal('token pair not found or supported: FAKE/TOKEN');
                    return [2 /*return*/];
            }
        });
    }); });
    it('should reject when quantity is below minAmount', function () { return __awaiter(_this, void 0, void 0, function () {
        var tokenPair, quantityInWei, err;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, ercdex_1.ErcDex.Utils.Tokens.getTokenPair('ZRX', 'WETH')];
                case 1:
                    tokenPair = _a.sent();
                    quantityInWei = new bignumber_js_1.BigNumber(tokenPair.minAmount).minus(.1);
                    return [4 /*yield*/, should_throw_1.shouldThrow(function () { return new limit_order_1.LimitOrder({
                            account: constants_1.RELAYER_WALLET_ADDRESS,
                            price: '.005',
                            provider: web3_provider_1.web3Wrapper().getProvider(),
                            baseTokenSymbol: 'ZRX',
                            quoteTokenSymbol: 'WETH',
                            quantityInWei: quantityInWei,
                            type: 'buy',
                            signerType: _0x_js_1.SignerType.Default
                        }).execute(); })];
                case 2:
                    err = _a.sent();
                    chai_1.expect(err.message).to.equal("order quantity must be greater than minimum allowed amount: " + quantityInWei + "/" + tokenPair.minAmount);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should reject when quantity is not an integer', function () { return __awaiter(_this, void 0, void 0, function () {
        var tokenPair, quantityInWei, err;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, ercdex_1.ErcDex.Utils.Tokens.getTokenPair('ZRX', 'WETH')];
                case 1:
                    tokenPair = _a.sent();
                    quantityInWei = new bignumber_js_1.BigNumber(tokenPair.minAmount).plus(.1);
                    return [4 /*yield*/, should_throw_1.shouldThrow(function () { return new limit_order_1.LimitOrder({
                            account: constants_1.RELAYER_WALLET_ADDRESS,
                            price: '.005',
                            provider: web3_provider_1.web3Wrapper().getProvider(),
                            baseTokenSymbol: 'ZRX',
                            quoteTokenSymbol: 'WETH',
                            quantityInWei: quantityInWei,
                            type: 'buy',
                            signerType: _0x_js_1.SignerType.Default
                        }).execute(); })];
                case 2:
                    err = _a.sent();
                    chai_1.expect(err.message).to.equal("order quantity must be an integer, got " + quantityInWei.toString());
                    return [2 /*return*/];
            }
        });
    }); });
    it('should reject when insufficient balance', function () { return __awaiter(_this, void 0, void 0, function () {
        var zeroEx, zrxToken, zrxBalance, err;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, web3_provider_1.zeroEx()];
                case 1:
                    zeroEx = _a.sent();
                    return [4 /*yield*/, ercdex_1.ErcDex.Utils.Tokens.getTokenBySymbol('ZRX')];
                case 2:
                    zrxToken = _a.sent();
                    return [4 /*yield*/, zeroEx.erc20Token.getBalanceAsync(zrxToken.address, constants_1.RELAYER_WALLET_ADDRESS)];
                case 3:
                    zrxBalance = _a.sent();
                    return [4 /*yield*/, should_throw_1.shouldThrow(function () { return new limit_order_1.LimitOrder({
                            account: constants_1.RELAYER_WALLET_ADDRESS,
                            price: '.0005',
                            provider: web3_provider_1.web3Wrapper().getProvider(),
                            baseTokenSymbol: 'ZRX',
                            quoteTokenSymbol: 'WETH',
                            quantityInWei: zrxBalance.plus(1),
                            type: 'sell',
                            signerType: _0x_js_1.SignerType.Default
                        }).execute(); })];
                case 4:
                    err = _a.sent();
                    chai_1.expect(err.message).to.equal("insufficient token balance");
                    return [2 /*return*/];
            }
        });
    }); });
    it('should reject when insufficient allowance', function () { return __awaiter(_this, void 0, void 0, function () {
        var zeroEx, tokenPair, minAmount, err, txHash;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, web3_provider_1.zeroEx()];
                case 1:
                    zeroEx = _a.sent();
                    return [4 /*yield*/, ercdex_1.ErcDex.Utils.Tokens.getTokenPair('ZRX', 'WETH')];
                case 2:
                    tokenPair = _a.sent();
                    minAmount = new bignumber_js_1.BigNumber(tokenPair.minAmount);
                    return [4 /*yield*/, zeroEx.erc20Token.setProxyAllowanceAsync(tokenPair.assetDataA.address, constants_1.RELAYER_WALLET_ADDRESS, new bignumber_js_1.BigNumber(0), constants_1.DEFAULT_TX_OPTIONS)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, should_throw_1.shouldThrow(function () { return new limit_order_1.LimitOrder({
                            account: constants_1.RELAYER_WALLET_ADDRESS,
                            price: '.0005',
                            provider: web3_provider_1.web3Wrapper().getProvider(),
                            baseTokenSymbol: 'ZRX',
                            quoteTokenSymbol: 'WETH',
                            quantityInWei: minAmount,
                            type: 'sell',
                            signerType: _0x_js_1.SignerType.Default
                        }).execute(); })];
                case 4:
                    err = _a.sent();
                    chai_1.expect(err.message).to.equal("insufficient allowance");
                    return [4 /*yield*/, zeroEx.erc20Token.setUnlimitedProxyAllowanceAsync(tokenPair.assetDataA.address, constants_1.RELAYER_WALLET_ADDRESS)];
                case 5:
                    txHash = _a.sent();
                    return [4 /*yield*/, zeroEx.awaitTransactionMinedAsync(txHash)];
                case 6:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be able to create a new order', function () { return __awaiter(_this, void 0, void 0, function () {
        var tokenPair, minAmount, accountOrderSink, pairOrderSink, order, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, ercdex_1.ErcDex.Utils.Tokens.getTokenPair('ZRX', 'WETH')];
                case 1:
                    tokenPair = _a.sent();
                    minAmount = new bignumber_js_1.BigNumber(tokenPair.minAmount);
                    accountOrderSink = new event_sink_1.EventSink(new ercdex_1.ErcDex.Events.AccountOrderChange(), { account: constants_1.RELAYER_WALLET_ADDRESS });
                    pairOrderSink = new event_sink_1.EventSink(new ercdex_1.ErcDex.Events.PairOrderChange(), { baseSymbol: 'ZRX', quoteSymbol: 'WETH' });
                    return [4 /*yield*/, new limit_order_1.LimitOrder({
                            account: constants_1.RELAYER_WALLET_ADDRESS,
                            price: '.0005',
                            provider: web3_provider_1.web3Wrapper().getProvider(),
                            baseTokenSymbol: 'ZRX',
                            quoteTokenSymbol: 'WETH',
                            quantityInWei: minAmount,
                            type: 'sell',
                            signerType: _0x_js_1.SignerType.Default
                        }).execute()];
                case 2:
                    order = _a.sent();
                    chai_1.expect(order.price).to.equal('0.0005');
                    return [4 /*yield*/, Promise.all([
                            accountOrderSink.verifyEventState(function (events) { return events.length === 1; }, 'expected to have one event after creating an order'),
                            accountOrderSink.verifyEventState(function (events) { return events[0] && events[0].eventType === 'created'; }, 'expected event to be type created'),
                            pairOrderSink.verifyEventState(function (events) { return events.length === 1; }, 'expected to have one event after creating an order'),
                            pairOrderSink.verifyEventState(function (events) { return events[0] && events[0].eventType === 'created'; }, 'expected event to be type created')
                        ])];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, new cancel_order_1.CancelOrder({
                            order: order,
                            provider: web3_provider_1.web3Wrapper().getProvider(),
                            signerType: _0x_js_1.SignerType.Default
                        }).execute()];
                case 4:
                    result = _a.sent();
                    chai_1.expect(result.orderHash).to.equal(order.orderHash);
                    chai_1.expect(result.success).to.equal(true);
                    return [4 /*yield*/, Promise.all([
                            accountOrderSink.verifyEventState(function (events) { return events.length === 2; }, 'expected to have two events after canceling an order'),
                            accountOrderSink.verifyEventState(function (events) { return events[1] && events[1].eventType === 'canceled'; }, 'expected event to be type canceled'),
                            pairOrderSink.verifyEventState(function (events) { return events.length === 2; }, 'expected to have two events after canceling an order'),
                            pairOrderSink.verifyEventState(function (events) { return events[1] && events[1].eventType === 'canceled'; }, 'expected event to be type canceled')
                        ])];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=limit-order.spec.js.map